/* ************************************************************************** */
/*                                             _____ _  __       ___   __     */
/*  Level.hpp                                 |  ___(_)/ _| ___ ( _ ) / /_    */
/*  Project: C-Engine                         | |_  | | |_ / _ \/ _ \| '_ \   */
/*                                            |  _| | |  _|  __/ (_) | (_) |  */
/*  Author: Fife <wasabifife@gmail.com>       |_|   |_|_|  \___|\___/ \___/   */
/*                                                                            */
/* ************************************************************************** */

#ifndef CENGINE_LEVEL_HPP
#define CENGINE_LEVEL_HPP

#include "..\Rework\CEngine.hpp"

class Level
{
    public:

        Level();//Constructeur

        void AffectEngine( Engine * v );
        Engine * GetEngine();

        void SetMap( const unsigned char * userTileset , unsigned char * userMap , bool * userProperties, int userTileWidth , int userTileHeight , int userWorldWidth , int userWorldHeight);

        int GetIdMap( int x, int y );
        void ReplaceIdMap( int x , int y, char v );

        void DrawMap();

        Object ** GetListeObject();
        int GetNbObject();

        void AddObject( Object * v); //Ajout un objet au level
        bool DelObject( Object * v , bool destroy = true); //Supprime l'objet
        void DelAllObject(); //Supprime tout les objets

        int tileWidth;
        int tileHeight;

        int levelWidth;
        int levelHeight;

        bool * solid;

    private:

        Engine * engineLink;

        unsigned char * map;

        const unsigned char * tileset;

        int tilegap;

        Object ** listeObject;
        int nbObject;
};

#endif
