#include "MonochromeLib.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "FonctionC.h"

PrintV(int x, int y, int v)
{
    char txt[10];
    sprintf(txt,"%d",v);
    PrintMini(x,y,txt,0);
}

void setFps(int fpsWish)
{
    static unsigned int fps = 0, fps_count = 0; // "static" permet de garder les valeurs en mmoire entre les diffrents appels

    do
    {
        fps = RTC_getTicks(); // on enregistre les ticks
        Sleep(1); // permet d'conomiser de la batterie
    }
    while(fps < fps_count + fpsWish); // tant que ceux-ci ne se sont pas suffisamment couls

    fps_count = RTC_getTicks(); // on met  jour les dernires valeurs
}

int getDelay( int ms)
{
    static int time=0;

    if(RTC_getTicks() - time >  (ms / 7.8125)) // si il s'est coul une seconde complte
    {
        time = RTC_getTicks(); // et on se rappelle du nombre de ticks de la dernire seconde coule
        return 1;
    }

return 0;

}

int getFps()
{
    // variables utilises (en static, pour pouvoir garder en mmoire les valeurs)
    static int disp_fps=0, fps=1, time=0;

    if(RTC_getTicks() - time > 128) // si il s'est coul une seconde complte
    {
        disp_fps = fps; // alors on rcupre le nombre de FPS
        fps = 0; // on remet  0 le compteur
        time = RTC_getTicks(); // et on se rappelle du nombre de ticks de la dernire seconde coule
    }

    fps++; // on monte la valeur des FPS

    return disp_fps;
}

int rand_int(int max)
{
    return rand() % max;
}

int rand_int_ab(int min, int max)
{
    return rand() % (max - min) + min;
}

static int SysCallCode[] = {0xD201422B,0x60F20000,0x80010070};
static int (*SysCall)( int R4, int R5, int R6, int R7, int FNo ) = (void*)&SysCallCode;

int RTC_getTicks(void)
{
     return (*SysCall)(0, 0, 0, 0, 0x3B); // on dclare la fonction voulue selon son numro (ici 0x3B)
}


float ABS( float v)
{
    if(v < 0) return -v;
    return v;
}

double degretorad(float v)
{
    return v * 3.1415 / 180;
}

double radtodegre(float v)
{
    return v * 180 / 3.1415;
}
